#!/bin/sh
#
# automat.sh: sendet den Inhalt der Datei $WORKDIR/017xxxxxxxx.sms
#             als sms an die Telefonnummer 017xxxxxxxx
#
# (c) Karsten Kreher 1997 kk@pixie.swb.de
#
# VERSION/AENDERUNGEN
#	1.0 nix
#
# bitte mailt mir Bugs/Verbesserungsvorschlaege!!!
# 
# BUGS:
#	- eplus noch nicht eingebaut mangels Testmoeglichkeit
#	- Dial-Prefix 0, wird nur als 0 ausgefuehrt, daher seltene
#	  Probleme mit dem Verbindungsaufbau bei Nebenstellenanlage
#	- D1 nicht sehr gut getestet, scheint aber zuverlaessig zu
#	  funktionieren
#
# sendet den Inhalt der Datei $WORKDIR/017xxxxxxxx.sms als sms an
# die Telefonnummer 017xxxxxxxx
# 
# INSTALLATION:
#	- alles in z.B. /usr/local/bin
#	- crontab von root oder dem kermit-user editieren
#	  siehe crontab.sample
#	- ggf. kermit installieren
#	- Anpassungen s.u.
#
# NOETIGE ANPASSUNGEN:
#	- Absendertelefonnummer in d1.ksc und d2.ksc editieren (siehe 7676767)
#	- in d1.ksc und d2.ksc das modem-Device, Modem-Typ, dial prefix
#	- Pfade kontrollieren
#	- cuaa in Benutzung? s.u. editieren (laeuft so auf Sun Solaris)
# 	  unter Linux modem/ttyS? checken
#
# Aufruf z.B. per cronjob alle 5 min.
#
# Dank an:
#	Erik Heinz <erik@iks-jena.de>	sms scripte
#

#set -x

umask 111

cd /usr/local/bin
# hier liegen die 01721234567.sms-Dateien
WORKDIR=/tmp/AUTOMAT
LOCKFILE=$WORKDIR/LOCK
DATESTRING="`date +%y%m%d-%H%M`"

# cuaa in Benutzung?
A="`/bin/ps -ef|grep -v grep|egrep 'cuaa|term\/a'`"
if [ -n "$A" ]; then
	echo "$DATESTRING: cuaa in Benutzung"
 	exit 0
fi

# eigenes Lockfile?
if [ -f $LOCKFILE ]; then
	echo "$DATESTRING: LOCK gefunden"
	LOCKPID="`cat $LOCKFILE|tr -d ' '`"
	if [ -z "`ps -ef|grep $LOCKPID|grep automat`" ]; then
		echo "    ... removing stale LOCK"
		/bin/rm $LOCKFILE
	else
		exit 0
	fi
fi

# D1, D2 only
FILES="`find /cad05/tmp/AUTOMAT -type f -name '017[12][0-9][0-9][0-9][0-9][0-9][0-9][0-9].sms' -print`"

if [ -z "$FILES" ]; then
	exit 0
fi

echo $$ >> $LOCKFILE

[ -n "$FILES" ] && echo "$DATESTRING: $FILES"

# beachte die Unterscheidung in D1 und D2 !
for i in $FILES; do
	TELNO=`basename $i .sms`
	
	/usr/local/bin/kermit /usr/local/bin/d`echo $TELNO|cut -c4`.ksc \
		-C "smssend $TELNO { `cat $i|tr '[A-Z]' '[a-z]'` }"

	STATUS=$?
	echo "$DATESTRING: kermit exit status $STATUS"
	
	if [ "$STATUS" = "0" ]; then
		/bin/mv $i $i.$DATESTRING.done
		/bin/cp $i.$DATESTRING.done \
			/tmp/AUTOMAT/`basename $i`.$DATESTRING.done
		/bin/rm $i.$DATESTRING.done
	fi
	
	# 45 sec scheint mir gut
	sleep 45
done

[ -f $LOCKFILE ] && /bin/rm $LOCKFILE
